from collections import OrderedDict
import math

particles = [
    ('electron', 0.510998e6 ),
    ('muon', 0.105658e9 ),
    ('proton', 0.938272e9 ),
    #('neutron', 0.939565e9 ),
    ('tau', 1.7768e9 ),
    ('up', 2.01e6 ),
    ('down', 4.79e6 ),
    ('strange', 0.090e9 ),
    ('charm', 1.29e9 ),
    ('bottom1', 4.18e9 ),
    ('bottom2', 4.65e9 ), 
    ('top', 173.07e9 ),
    ('higgs0', 126.0e9 ),
    ('higgs+', 125.3e9 ), 
]

pdict = OrderedDict(particles)

print pdict

def search_fraction(num, max_div=12, accuracy=0.01):
    best_accuracy = 10000.0
    for i in range(2, max_div*200):
        for j in range(2, max_div):
            n = abs(num / i * j - 1) * j
            if n < best_accuracy:
                best_accuracy = n
                best = (n, i, j)
    if best_accuracy > accuracy:
        return None
    return best

def show_ratio(pdict, name1, name2, power, results):
    m1 = pdict[name1]
    m2 = pdict[name2]
    if m1 > m2:
        tmp = m1
        m1 = m2
        m2 = tmp
        tmp = name1
        name1 = name2
        name2 = tmp
    #m2 = math.log(m2)
    #m1 = math.log(m1)
    #print m2, m1
    x = pow(m2 / m1, power)
    f = search_fraction(x)
    if f is None:
        print "%10s:%10s %7f:%7f" % \
            (name2, name1, m2, m1)
    else:
        print "%10s:%10s %.2f %7f:%7f - %4d/%4d %7f (%f)" % \
            (name2, name1, power, m2, m1, f[1], f[2], x, f[0])
        if x < 5:
            results.append((f[0], f[1], f[2], name2, name1, m2, m1, power, x))

results = []
for name1 in pdict.keys(): #['proton', 'charm', 'bottom1']:
    for name2 in pdict.keys():
        if name1 != name2:
            show_ratio(pdict, name2, name1, 1./3, results)
            show_ratio(pdict, name2, name1, 0.25, results)
            show_ratio(pdict, name2, name1, 0.5, results)
            show_ratio(pdict, name2, name1, 2./3, results)

print

results.sort()
for f in results:
    print "%10s:%10s %.2f %9.3g:%9.3g - %4d/%4d %7f (%f)" % \
        (f[3], f[4], f[7], f[5], f[6], f[1], f[2], f[8], f[0])
